Index: trunk/LMDZ.TITAN/libf/phytitan/phyetat0.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/phyetat0.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/phyetat0.F	(revision 175)
@@ -7,5 +7,5 @@
      .            rlat,rlon, tsol,tsoil,
      .           albe, solsw, sollw,
-     .           fder,radsol,
+     .           fder,radsol,resch4,
      .           tabcntr0,
      .           t_ancien,ancien_ok)
@@ -25,5 +25,5 @@
       REAL dtime
       INTEGER radpas,chimpas
-      REAL rlat(klon), rlon(klon)
+      REAL rlat(klon), rlon(klon)   ! in degrees
       REAL tsol(klon)
       REAL tsoil(klon,nsoilmx)
@@ -40,4 +40,7 @@
       LOGICAL ancien_ok
 
+      REAL resch4(klon)
+      INTEGER ig0
+
       REAL xmin, xmax
 c
@@ -329,4 +332,36 @@
          ENDIF
       ENDIF
+c     Par defaut on cree 2 bandes de methane au pole Nord et au pole Sud
+c     (entre 75 et 85 degres de latitude) de 2 metres.
+c     Les poles sont sec !
+      resch4(1) = 0.    ! pole nord = 1 point
+      DO ig0=2,klon
+          if ((rlat(ig0).ge.75..and.rlat(ig0).le.85.).or. 
+     &        (rlat(ig0).ge.-85.and.rlat(ig0).le.-75.)) then
+            resch4(ig0) = 2.
+          else
+            resch4(ig0) = 0.
+          endif
+      ENDDO
+      resch4(klon) = 0.   ! pole sud = 1 point
+
+      ierr = NF_INQ_VARID (nid, "RESCH4", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, "phyetat0: Le champ <RESCH4> est absent"
+         PRINT*, "Pas de reservoir de methane mais je continue..."
+         PRINT*, "Pour info, je met 2 metres de methane sur 2 bandes"
+         PRINT*, "comprises entre 75 et 85 degres de latitude dans  "
+         PRINT*, "chaque hemisphere."
+      ELSE
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, resch4)
+#else
+         ierr = NF_GET_VAR_REAL(nid, nvarid,resch4)
+#endif
+         IF (ierr.NE.NF_NOERR) THEN
+            PRINT*, "phyetat0: Lecture echouee pour <reservoir>"
+            CALL abort
+         ENDIF
+      ENDIF
 c
 c Fermer le fichier:
Index: trunk/LMDZ.TITAN/libf/phytitan/phyredem.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/phyredem.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/phyredem.F	(revision 175)
@@ -7,5 +7,5 @@
      .           albedo, 
      .           solsw, sollw,fder,
-     .           radsol,
+     .           radsol,resch4,
      .           t_ancien)
 
@@ -34,4 +34,5 @@
       real fder(klon)
       REAL radsol(klon)
+      real resch4(klon)
       REAL t_ancien(klon,klev)
 c
@@ -243,4 +244,19 @@
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid, "RESCH4", NF_DOUBLE, 1, idim2,nvarid)
+#else
+      ierr = NF_DEF_VAR (nid, "RESCH4", NF_FLOAT, 1, idim2,nvarid)
+#endif
+      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 26,
+     .                        "Reservoir CH4 a la surface")
+      ierr = NF_ENDDEF(nid)
+#ifdef NC_DOUBLE
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,resch4)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,resch4)
+#endif
+c
+      ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
       ierr = NF_DEF_VAR (nid, "TANCIEN", NF_DOUBLE, 1, idim3,nvarid)
 #else
Index: trunk/LMDZ.TITAN/libf/phytitan/physiq.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/physiq.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/physiq.F	(revision 175)
@@ -79,4 +79,7 @@
 #include "logic.h"
 #include "comorbit.h"
+#include "microtab.h"
+#include "diagmuphy.h"
+#include "itemps.h"
 c======================================================================
       LOGICAL ok_mensuel ! sortir le fichier mensuel
@@ -395,4 +398,6 @@
 c Recuperation des TAU du TR
       REAL t_tauhvd(klon,klev),t_khvd(klon,klev)
+      REAL t_tcld(klon,klev),t_kcld(klon,klev)
+      REAL t_kcvd(klon,klev)
 c  ASTUCE POUR EVITER klon... EN ATTENDANT MIEUX
       INTEGER   ngrid
@@ -401,9 +406,25 @@
       PARAMETER (NSPECV=24,NSPECI=46,NLAYER=llm)
       REAL TAUHID(ngrid,NLAYER,NSPECI)
+     &               ,TAUCID(ngrid,NLAYER,NSPECI)
      &               ,TAUGID(ngrid,NLAYER,NSPECI)
      &               ,TAUHVD(ngrid,NLAYER,NSPECV)
+     &               ,TAUCVD(ngrid,NLAYER,NSPECV)
      &               ,TAUGVD(ngrid,NLAYER,NSPECV)
 
-      COMMON /TAUD/   TAUHID,TAUGID,TAUHVD,TAUGVD
+      COMMON /TAUD/   TAUHID,TAUCID,TAUGID,TAUHVD,TAUCVD,TAUGVD
+* common relatifs au nuages
+      real rmcbar(ngrid,NLAYER),xfbar(ngrid,NLAYER,4) 
+      integer ncount(ngrid,NLAYER)
+      COMMON/rnuabar/ncount,rmcbar,xfbar
+
+       REAL ch4(klon,jjm+1),dch4(jjm+1)
+       INTEGER ig0
+       integer ich4
+       common/ch4ind/ich4
+
+c     flux de chaleur latente d'evaporation CH4
+      REAL fclat(klon)
+c     reservoir de surface
+      REAL,save,allocatable :: reservoir(:)
 
 c Declaration des constantes et des fonctions thermodynamiques
@@ -446,4 +467,5 @@
          allocate(solsw(klon),sollw(klon),sollwdown(klon))
          allocate(source(klon,nqmax))
+         allocate(reservoir(klon))
 
          CALL suphec ! initialiser constantes et parametres phys.
@@ -458,7 +480,8 @@
 c Initialiser les compteurs:
 c
-         itap     = 0
-         itaprad  = 0
-         itapchim = 0
+         itap        = 0
+         itaprad     = 0
+         itapchim    = 0
+         ncount(:,:) = 0
 
 c         
@@ -469,5 +492,5 @@
      .       rlatd,rlond,ftsol,ftsoil,
      .       falbe, solsw, sollw,
-     .       dlw,radsol,
+     .       dlw,radsol,reservoir,
 c     .      zmea,zstd,zsig,zgam,zthe,zpic,zval,
      .       tabcntr0,
@@ -575,8 +598,14 @@
 c Verifications:
 c
-      if ((nmicro.eq.0).and.(microfi.eq.1)) then
-        print*,"MICROPHYSIQUE ONLINE, MAIS NMICRO=0..."
-	stop
-      endif
+         IF ((nmicro.eq.0).and.(microfi.eq.1)) THEN
+           abort_message="MICROPHYSIQUE ONLINE, MAIS NMICRO=0..."
+           call abort_gcm(modname,abort_message,1) 
+         ENDIF
+         IF (microfi.lt.1.and.clouds.eq.1) THEN
+          write(lunout,*)"microfi.lt.1.and.clouds.eq.1"
+          abort_message = 
+     &    "Impossible de faire des nuages sans microphysique..."
+          call abort_gcm(modname,abort_message,1)
+         ENDIF
          IF (nlon .NE. klon) THEN
             WRITE(lunout,*)'nlon et klon ne sont pas coherents', nlon, 
@@ -650,8 +679,14 @@
       ENDDO
 
+      rmcbar  = 0.
+      xfbar   = 0.
          
       ENDIF ! debut
 c====================================================================
 c======================================================================
+
+c   Creer un reservoir de surface infini 
+c
+      reservoir(:) = 2.
 
 c Mettre a zero des variables de sortie (pour securite)
@@ -1061,22 +1096,74 @@
 
       if (iflag_trac.eq.1) then
+c         call begintime(tt0)
          call phytrac (debut,lafin,
      .                   nqmax,nmicro,dtime,appel_chim,dtimechim,
      .                   paprs,pplay,delp,t,rmu0,fract,pdecli,zls,
-     .                   tr_seri,qaer,d_tr_mph,d_tr_kim)
-
-        if (microfi.eq.1) then
+     .                   yu1,yv1,zzlev,zzlay,ftsol,
+     .                   tr_seri,qaer,d_tr_mph,d_tr_kim,
+     .                   fclat,reservoir)
+
+c         call endtime(tt0,tt1)
+c         ttphytra=ttphytra+tt1
+
+c ----- ICI on ajuste radsol en tenant compte du flux de chaleur latente 
+c       d'evaporation du reservoir.
+c       NOTE : c'est pas tres elegant mais ca permet d'eviter d'aller
+c              toucher a clmain.
+        if (clouds.eq.1) then
+          radsol(:) = radsol(:)+fclat(:)    !test pas de flx de chaleur latente
+        endif
+
+        if (microfi.ge.1) then
          tr_seri(:,:,1:nmicro) = tr_seri(:,:,1:nmicro)
      .                        + d_tr_mph(:,:,1:nmicro)*dtime
 	endif
+c       PAS ELEGANT mais je n'ai pas trouve d'autres solutions :
+c       Il semblerait qu'il y ait un probleme lorsque les tendances de traceurs
+c       retourne des traceurs nuls et il y a parfois des valeurs negatives qui trainent.
+c       Pour ne diffuser le probleme, on force les valeurs negatives a ZERO.
+        DO iq=1,nmicro
+          DO i=1,klon
+            DO l=1,klev
+              if (tr_seri(i,l,iq).lt.0.) then
+                 tr_seri(i,l,iq) = 0.
+              endif
+            ENDDO
+          ENDDO
+        ENDDO
+
+c condensation:
+c       NE PAS OUBLIER LA CONDENSATION DES NUAGES !!!!
+        if ((clouds.eq.1.or.(chimi)).and.nqmax.gt.nmicro) then
+          tr_seri(:,:,nmicro+1:nqmax) = tr_seri(:,:,nmicro+1:nqmax)
+     .                         + d_tr_mph(:,:,nmicro+1:nqmax)*dtime
+        endif
         if ((chimi).and.(nqmax.gt.nmicro)) then
 c chimie:
          tr_seri(:,:,:) = tr_seri(:,:,:) + d_tr_kim(:,:,:)*dtime
-c condensation:
-         tr_seri(:,:,nmicro+1:nqmax) = tr_seri(:,:,nmicro+1:nqmax)
-     .                        + d_tr_mph(:,:,nmicro+1:nqmax)*dtime
 	endif
 
       endif
+
+c       ch4=0.
+c       do l=1,llm
+c         ch4(1,l) = tr_seri(1,l,ich4)
+c         do j=2,jjm
+c           ig0=1+(j-2)*iim
+c           do i=1,iim
+c             ch4(j,l)= ch4(j,l)  + tr_seri(ig0+i,l,ich4)/iim
+c           enddo
+c         enddo
+c         ch4(jjm+1,l) = tr_seri(klon,l,ich4)
+c       enddo
+c       do j=1,jjm+1
+c         write(501,*) j,ch4(j,1)
+c       enddo
+c       do l=1,llm
+c         write(502,'(I3,49(ES24.17,1X))') l, 
+c     &   (ch4(j,l),j=1,jjm+1)
+c       enddo
+c       write(501,*) ""
+c       write(502,*) ""
 
 c------------------
@@ -1107,4 +1194,18 @@
 c     print*,"sollw avant radlwsw=",sollw(klon/2)
 c     print*,"avant radlwsw"
+
+c   ----------------
+c   Calcul du rayon moyen des gouttes et des fractions volumique pour le TR
+c  ----------------
+      IF (clouds.eq.1) THEN
+        DO i=1,klon
+          DO j=1,klev
+            rmcbar(i,j)=rmcbar(i,j)/MAX(FLOAT(ncount(i,j)),1.)
+            xfbar(i,j,:)=xfbar(i,j,:)/MAX(FLOAT(ncount(i,j)),1.)
+          ENDDO 
+        ENDDO
+      ENDIF
+     
+c      call begintime(tt0)
       CALL radlwsw
      e            (dist, rmu0, fract, dtimerad, zzlev,
@@ -1115,5 +1216,14 @@
      s             sollwdown,
      s             lwnet, swnet)
+c      call endtime(tt0,tt1)
+c      ttrad=ttrad+tt1
+
 c     print*,"apres radlwsw"
+c     mise a zero du rayon moyen des gouttes et des fractions volumique 
+      IF (clouds.eq.1) THEN
+        rmcbar(:,:)  = 0.
+        xfbar(:,:,:) = 0.
+        ncount(:,:)  = 0
+      ENDIF
 
 c     print*,"radsol apres radlwsw=",radsol(klon/2)
@@ -1122,7 +1232,7 @@
       itaprad = 0
       DO k = 1, klev
-      DO i = 1, klon
+       DO i = 1, klon
          dtrad(i,k) = heat(i,k)-cool(i,k)     !K/s
-      ENDDO
+       ENDDO
       ENDDO
 c       print*,"heat (K/s) =",heat(klon/2,:)
@@ -1426,15 +1536,4 @@
       ENDDO
 c
-c incrementation de la tendance (repassee en extensif) sur qaer pour sorties
-      if (microfi.eq.1) then
-      do iq=1,nmicro
-         DO l=1,llm
-          DO i = 1, klon
-            qaer(i,l,iq) = qaer(i,l,iq) +
-     .                (d_tr_mph(i,l,iq)*delp(i,l)/RG)*dtime
-          ENDDO
-         ENDDO
-      enddo
-      endif   ! microfi
 c=============================================================
 c   Ecriture des sorties
@@ -1502,5 +1601,5 @@
      .      falbe,
      .      solsw, sollw,dlw,
-     .      radsol,
+     .      radsol,reservoir,
 c     .      zmea,zstd,zsig,zgam,zthe,zpic,zval,
      .      t_ancien)
